// ************************************************************* 
// Programmbeispiel: Echtzeituhr PCF8563 ueber I2C-Bus                                
// Datum: 21.9.2005: mpa										 
//  
                                   

#include<reg517a.h>
#include<stdio.h>
#include<lcd.h>
#include<i2c.h>

#define RTC			0xA2				// PCF8563 I2C - Adresse 10100010 (schreiben)
#define TASTENPORT	P7					// Tastaturdekoder ist an Port 7 
sbit 	TASTENDRUCK	= P3^2;				// Tastedruck Puls an     P3^2   (INT0) aktiv LOW

// Globale variablen (beginnen mit g...)
char gTXT[25];							// Allgemeiner Textbuffer
char gTaste;							// Nummer der gedrueckten Taste
char gNeueTaste;						// Signalisiert neuen Tastendruck




// Deklaration der Funktionen



main()
{
unsigned char Daten;						// Allgemeine Variable
unsigned char Taste;						// Taste
unsigned char bcd;							// BCD-Zahl
unsigned char hz,he,mz,me;					// Stunden Zehner,Einer Minuten Zehner,einer
unsigned char h,m,s;						// Stunden, Minuten, Sekunden  

i2c_init();									// I2C-Bus initialisieren
init_lcd();									// LCD initialisieren
blank_lcd();								// LCD loeschen


sprintf(gTXT,"Uhrzeit (hh:mm)");			// String beschreiben
print_lcd(1,1,gTXT);						// String auf LCD ausgeben. Zeile 1
sprintf(gTXT,"         __:__  ");			// String beschreiben
print_lcd(2,1,gTXT);						// String auf LCD ausgeben. Zeile 2


while(TASTENDRUCK)	{;}						// Warte bis Taste gedrueckt (LOW) wird
hz = TASTENPORT & 0x0F;						// Einlesen der Tasten und Maskieren der Portbits 0-3
sprintf(gTXT,"         %1bx_:__  ",hz);		// Stunden Zehner schreiben
print_lcd(2,1,gTXT);						// String auf LCD ausgeben. Zeile 2
bcd = hz << 4;								// 4 Bit nach links schieben um BCD Zahl zu erzeugen (Zehner)
while(TASTENDRUCK==0)	{;}					// Warte bis Taste wieder losgelassen wird (HIGH)

while(TASTENDRUCK)	{;}						// Warte bis Taste gedrueckt (LOW) wird
he = TASTENPORT & 0x0F;						// Einlesen der Tasten und Maskieren der Portbits 0-3
sprintf(gTXT,"         %1bx%1bx:__  ",hz,he);	// Stunden Zehner, Stunden Einer schreiben
print_lcd(2,1,gTXT);						// String auf LCD ausgeben. Zeile 2
bcd = bcd | he;								// Einer zu BCD Zahl hinzufuegen 
I2C_Schreiben(RTC, 0x04, bcd);				// Register 04:	Stunden schreiben in BCD
while(TASTENDRUCK==0)	{;}					// Warte bis Taste wieder losgelassen wird (HIGH)

while(TASTENDRUCK)	{;}						// Warte bis Taste gedrueckt (LOW) wird
mz = TASTENPORT & 0x0F;						// Einlesen der Tasten und Maskieren der Portbits 0-3
sprintf(gTXT,"         %1bx%1bx:%1bx_  ",hz,he,mz);		// Minuten Zehner schreiben
print_lcd(2,1,gTXT);						// String auf LCD ausgeben. Zeile 2
bcd = mz << 4;								// 4 Bit nach links schieben um BCD Zahl zu erzeugen (Zehner)
while(TASTENDRUCK==0)	{;}					// Warte bis Taste wieder losgelassen wird (HIGH)

while(TASTENDRUCK)	{;}						// Warte bis Taste gedrueckt (LOW) wird
me = TASTENPORT & 0x0F;						// Einlesen der Tasten und Maskieren der Portbits 0-3
sprintf(gTXT,"         %1bx%1bx:%1bx%1bx  ",hz,he,mz,me);		// Minuten Zehner, Minuten Einer schreiben
print_lcd(2,1,gTXT);						// String auf LCD ausgeben. Zeile 2
bcd = bcd | me;								// Einer zu BCD Zahl hinzufuegen 
I2C_Schreiben(RTC, 0x03, bcd);				// Register 03:	Minuten schreiben in BCD
while(TASTENDRUCK==0)	{;}					// Warte bis Taste wieder losgelassen wird (HIGH)	


I2C_Schreiben(RTC, 0x02, 0x00);				// Register 02:	Sekunden auf Null setzen


sprintf(gTXT,"                        ");	// Zeile loeschen	
print_lcd(1,1,gTXT);						// String auf LCD ausgeben. Zeile 1
print_lcd(2,1,gTXT);						// String auf LCD ausgeben. Zeile 2

while(1)										// Endlosschleife
	{
	h = I2C_Lesen(RTC,0x04);					// Stunden auslesen
	h = h & 0x3F;								// Stunden masieren
	m = I2C_Lesen(RTC,0x03);					// Minuten auslesen
	m = m & 0x7F;								// Minuten masieren
	s = I2C_Lesen(RTC,0x02);					// Minuten auslesen
	s = s & 0x7F;								// Minuten masieren
														// Zeit ausgeben, 2xBCD kann dierekt als HEX
	sprintf(gTXT,"Zeit:   %2bx:%02bx:%b02x",h,m,s);		// Fuehrende Nullen bei Min. und Sek.
	print_lcd(1,1,gTXT);						// String auf LCD ausgeben. Zeile 1
	}
}


// Funktionen


